mostly fixes
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 use_color=false
145 if [[ $- == *i* ]]; then
146 # for readline-complete.el
147 if [[ $LC_INSIDE_EMACS ]]; then
148 # all for readline-complete.el
149 stty echo
150 bind 'set horizontal-scroll-mode on'
151 bind 'set print-completions-horizontally on'
152 bind '"\C-i": self-insert'
153 else
154
155
156 if [[ $TERM != dumb ]] && test -t 1; then
157 use_color=true
158 fi
159
160 if [[ $KONSOLE_PROFILE_NAME ]]; then
161 TERM=xterm-256color
162 fi
163
164 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
165 # todo: we should try installing the alacritty terminfo if it is not found
166 # https://github.com/alacritty/alacritty/issues/2838
167 TERM=xterm-256color
168 fi
169
170 # copying from the alacritty example above,
171 if [[ $TERM == xterm-kitty ]]; then
172 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
173 TERM=xterm-256color
174 else
175 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
176 KITTY_SHELL_INTEGRATION=t
177 source /a/opt/kitty/shell-integration/bash/kitty.bash
178 fi
179 fi
180 fi
181
182 # todo: not sure this works in sakura
183 #stty werase undef
184 #bind "\C-w": kill-region
185 # sakura == xterm-256color
186 # konsole == xterm
187 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
188 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
189 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
190 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
191 else
192 # make ctrl-backspace work. for konsole, i fixed it through
193 # /home/iank/.local/share/konsole/default.keytab
194 stty werase ^h
195 bind '"\eOc": shell-forward-word'
196 bind '"\eOd": shell-backward-word'
197 fi
198 # i cant remember why i did this, probably to free up some keys to bind
199 # to other things in bash.
200 # other than C-c and C-z, the rest defined by stty -a are, at least in
201 # gnome-terminal, overridden by bash, or disabled by the system
202 stty lnext undef stop undef start undef
203 fi
204
205 fi
206
207 case $TERM in
208 # fixup broken backspace in chroots
209 xterm-kitty|alacritty)
210 chroot() {
211 TERM=xterm-256color command chroot "$@"
212 }
213 ;;
214 esac
215
216 export BC_LINE_LENGTH=0
217
218 # ansible option
219 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
220
221 # note, if I use a machine I dont want files readable by all users, set
222 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
223
224 # i for insensitive. the rest from
225 # X means dont remove the current screenworth of output upon exit
226 # R means to show colors n things
227 export LESS=RXij12
228 export SYSTEMD_LESS=$LESS
229
230 export NNN_COLORS=2136
231
232 export SL_FILES_DIR=/b/ds/sl/.iank
233 export SL_INFO_DIR=/p/sshinfo
234
235
236 # * include files
237
238 if [[ -s $bashrc_dir/path-add-function ]]; then
239 source $bashrc_dir/path-add-function
240 if [[ $SSH_CLIENT ]]; then
241 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
242 export EMACSDIR=/home/iank/.iank/e/e
243 fi
244 path-add $bashrc_dir
245 fi
246 fi
247
248 # if someone exported $SOE (stop on error), catch errors.
249 #
250 # Note, on debian this results in the following warning when in ssh,
251 # hich I haven't figured out how to fix. It doesn't happen if we source
252 # after the shell has started
253 #
254 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
255 # bash: warning: cannot start debugger; debugging mode disabled
256 if [[ $SOE ]]; then
257 if [[ -e /a/bin/errhandle/err ]]; then
258 source /a/bin/errhandle/err
259 fi
260 fi
261
262 # based on readme.debian. dunno if this will break on other distros.
263 if [[ -s /usr/share/wcd/wcd-include.sh ]]; then
264 source /usr/share/wcd/wcd-include.sh
265 fi
266
267
268 mysrc() {
269 local path dir file
270 path=$1
271 dir=${path%/*}
272 file=${path##*/}
273 if [[ -s $path ]]; then
274 source $path
275 elif [[ -s $bashrc_dir/$file ]]; then
276 source $bashrc_dir/$file
277 fi
278 }
279
280
281 mysrc /a/bin/small-misc-bash/ll-function
282 mysrc /a/bin/distro-functions/src/package-manager-abstractions
283
284
285 # * functions
286 ccomp() { # copy completion
287 local src=$1
288 local c
289 shift
290 if ! c=$(complete -p $src 2>/dev/null); then
291 _completion_loader $src &>/dev/null ||:
292 c=$(complete -p $src 2>/dev/null) || return 0
293 fi
294 # remove $src( .*|$)
295 c=${c% $src}
296 c=${c%% $src *}
297 eval $c $*
298 }
299
300
301 ..() { c ..; }
302 ...() { c ../..; }
303 ....() { c ../../..; }
304 .....() { c ../../../..; }
305 ......() { c ../../../../..; }
306
307 chere() {
308 local f path
309 for f; do
310 path=$(readlink -e "$f")
311 echo "cat >$path <<'EOF'"
312 cat "$f"
313 echo EOF
314 done
315 }
316
317
318 # file cut copy and paste, like the text buffers :)
319 # I havnt tested these.
320 _fbufferinit() { # internal use
321 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
322 rm -rf "${my_f_tempdir:?}"/*
323 }
324 fcp() { # file cp
325 _fbufferinit
326 cp "$@" "$my_f_tempdir"/
327 }
328 fct() { # file cut
329 _fbufferinit
330 mv "$@" "$my_f_tempdir"/
331 }
332 fpst() { # file paste
333 [[ $2 ]] && { echo too many arguments; return 1; }
334 target=${1:-.}
335 cp "$my_f_tempdir"/* "$target"
336 }
337
338 _khfix_common() {
339 local host ip port file key
340 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
341 file=$(readlink -f ~/.ssh/known_hosts)
342 if [[ ! $ip ]]; then
343 echo "khfix: ssh failed"
344 return 1
345 fi
346 if [[ $port != 22 ]]; then
347 ip_entry="[$ip]:$port"
348 host_entry="[$host]:$port"
349 else
350 ip_entry=$ip
351 host_entry=$host
352 fi
353 tmpfile=$(mktemp)
354 if [[ $host != $ip ]]; then
355 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
356 if [[ $key ]]; then
357 grep -Fv "$key" "$file" | sponge "$file"
358 fi
359 fi
360 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
361 if [[ $key ]]; then
362 grep -Fv "$key" "$file" | sponge "$file"
363 fi
364 ll ~/.ssh/known_hosts
365 rootsshsync
366 }
367 khfix() { # known hosts fix
368 _khfix_common "$@" || return 1
369 ssh $1 :
370 }
371 khcopy() {
372 _khfix_common "$@"
373 ssh-copy-id $1
374 }
375
376 a() {
377 local x
378 x=$(readlink -nf "${1:-$PWD}")
379 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
380 echo -n "$x" | xclip -selection clipboard
381 echo -n "$x" | xclip
382 }
383
384 # a1 = awk {print $1}
385 for field in {1..20}; do
386 eval a$field"() { awk '{print \$$field}'; }"
387 done
388 # h1 = head -n1
389 for num in {1..9}; do
390 eval h$num"() { head -n$num; }"
391 done
392
393
394 b() {
395 # backwards
396 c -
397 }
398
399 hexipv4() {
400 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
401 }
402
403 vp9() {
404 local f out outdir in
405 outdir=vp9
406 case $1 in
407 --out)
408 outdir=$2
409 shift 2
410 ;;
411 esac
412 m mkdir -p $outdir
413 for f; do
414 out=$PWD/$outdir/$f
415 in=$PWD/$f
416 m cd $(mktemp -d)
417 pwd
418 m ffmpeg -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
419 m ffmpeg -y -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
420 cd -
421 done
422 }
423
424 utcl() { # utc 24 hour time to local hour 24 hour time
425 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
426 }
427
428 # c. better cd
429 if type -p wcd &>/dev/null; then
430 if [[ $LC_INSIDE_EMACS ]]; then
431 c() { wcd -c -z 50 -o "$@"; }
432 else
433 # lets see what the fancy terminal does from time to time
434 c() { wcd -c -z 50 "$@"; }
435 fi
436 else
437 c() { cd "$@"; }
438 fi
439 ccomp cd c
440
441 c4() { c /var/log/exim4; }
442
443 caa() { git commit --amend --no-edit -a; }
444
445 cf() {
446 for f; do
447 hr
448 echo "$f"
449 hr
450 cat "$f"
451 done
452 }
453 caf() {
454 # shellcheck disable=SC2033
455 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
456 -o -name .hg -prune -o -name .editor-backups -prune \
457 -o -name .undo-tree-history -prune \) \
458 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
459
460 }
461 ccomp cat cf caf
462
463 calc() { echo "scale=3; $*" | bc -l; }
464 # no having to type quotes, but also no command history:
465 clc() {
466 local x
467 read -r x
468 echo "scale=3; $x" | bc -l
469 }
470
471 cam() {
472 git commit -am "$*"
473 }
474
475 ccat () { # config cat. see a config without extra lines.
476 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
477 }
478 ccomp grep ccat
479
480 chrbind() {
481 local d
482 # dev/pts needed for pacman signature check
483 for d in dev proc sys dev/pts; do
484 [[ -d $d ]]
485 if ! mountpoint $d &>/dev/null; then
486 m s mount -o bind /$d $d
487 fi
488 done
489 }
490 chumount() {
491 local d
492 # dev/pts needed for pacman signature check
493 for d in dev proc sys dev/pts; do
494 [[ -d $d ]]
495 if mountpoint $d &>/dev/null; then
496 m s umount $d
497 fi
498 done
499 }
500
501
502 _cdiff-prep() {
503 # join options which are continued to multiples lines onto one line
504 local first=true
505 while IFS= read -r line; do
506 # remove leading spaces/tabs. assumes extglob
507 if [[ $line == "[ ]*" ]]; then
508 line="${line##+( )}"
509 fi
510 if $first; then
511 pastline="$line"
512 first=false
513 elif [[ $line == *=* ]]; then
514 echo "$pastline" >> "$2"
515 pastline="$line"
516 else
517 pastline="$pastline $line"
518 fi
519 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
520 echo "$pastline" >> "$2"
521 }
522
523 cdiff() {
524 # diff config files,
525 # setup for format of postfix, eg:
526 # option = stuff[,]
527 # [more stuff]
528 local pastline unified f1 f2
529 unified="$(mktemp)"
530 f1="$(mktemp)"
531 f2="$(mktemp)"
532 _cdiff-prep "$1" "$f1"
533 _cdiff-prep "$2" "$f2"
534 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
535 while IFS= read -r line; do
536 # the default bright red / blue doesnt work in emacs shell
537 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
538 done < "$unified"
539 }
540
541
542 cat-new-files() {
543 local start=$SECONDS
544 local dir="$1"
545 inotifywait -m "$dir" -e create -e moved_to |
546 # shellcheck disable=SC2030
547 while read -r filedir _ file; do
548 cat "$filedir$file"
549 hr
550 calc $((SECONDS - start)) / 60
551 sleep 5
552 done
553
554 }
555
556 # shellcheck disable=SC2032
557 chown() {
558 # makes it so chown -R symlink affects the symlink and its target.
559 if [[ $1 == -R ]]; then
560 shift
561 command chown -h "$@"
562 command chown -R "$@"
563 else
564 command chown "$@"
565 fi
566 }
567
568 cim() {
569 git commit -m "$*"
570 }
571
572 cl() {
573 # choose recent directory. cl = cd list
574 c =
575 }
576
577 d() { builtin bg "$@"; }
578 ccomp bg d
579
580 dc() {
581 diff --strip-trailing-cr -w "$@" # diff content
582 }
583 ccomp diff dc
584
585 despace() {
586 local x y
587 for x in "$@"; do
588 y="${x// /_}"
589 safe_rename "$x" "$y"
590 done
591 }
592
593 dig() {
594 command dig +nostats +nocmd "$@"
595 }
596 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
597 digsort() {
598 local sec
599 sec=
600 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
601 if [[ $l == [^\;]* ]]; then
602 sec+="$l"$'\n'
603 else
604 if [[ $sec ]]; then
605 printf "%s" "$sec" | sort
606 sec=
607 fi
608 printf "%s\n" "$l"
609 fi
610 done
611 }
612 ccomp dig digsort
613 # compare digs to the 2 servers
614 # usage: digdiff @server1 @server2 DIG_ARGS
615 # note: only the soa master nameserver will respond with
616 # ra "recursive answer" flag. That difference is meaningless afaik.
617 digdiff() {
618 local s1 s2
619 s1=$1
620 shift
621 s2=$1
622 shift
623 digsort $s1 "$@" | tee /tmp/digdiff
624 diff -u /tmp/digdiff <(digsort $s2 "$@")
625 }
626
627 dt() {
628 date "+%A, %B %d, %r" "$@"
629 }
630 ccomp date dt
631
632 dus() { # du, sorted, default arg of
633 du -sh ${@:-*} | sort -h
634 }
635 ccomp du dus
636
637
638 e() { echo "$@"; }
639
640 # echo args
641 ea() {
642 if (( ! $# )); then
643 echo no args
644 fi
645 for arg; do
646 printf "%qEOL\n" "${arg}"
647 printf "%s" "${arg}" |& hexdump -C
648 done
649 }
650 # echo vars. print var including escapes, etc
651 ev() {
652 if (( ! $# )); then
653 echo no args
654 fi
655 for arg; do
656 if [[ -v $arg ]]; then
657 printf "%qEOL\n" "${!arg}"
658 printf "%s" "${!arg}" |& hexdump -C
659 else
660 echo arg $arg is unset
661 fi
662 done
663 }
664
665 ediff() {
666 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
667 emacs --eval "(ediff-files \"$1\" \"$2\")"
668 }
669
670 # mail related
671 etail() {
672 tail -F /var/log/exim4/mainlog -n 200 "$@"
673 }
674 ccomp tail etail
675
676 # print exim old pids
677 eoldpids() {
678 local configtime pid piduptime now daemonpid
679 printf -v now '%(%s)T' -1
680 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
681 if [[ -s /run/exim4/exim.pid ]]; then
682 daemonpid=$(cat /run/exim4/exim.pid)
683 fi
684 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
685 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
686 if [[ $pid == $daemonpid ]]; then
687 continue
688 fi
689 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
690 if (( configtime > now - piduptime )); then
691 echo $pid
692 fi
693 done
694 }
695
696 # exim tail but only watch lines from new pids
697 etailnew() {
698 local pid oldpids
699 for pid in $(eoldpids); do
700 oldpids+="$pid|"
701 done
702 if [[ $oldpids ]]; then
703 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
704 else
705 etail
706 fi
707 }
708 # exim watch as old pids go away
709 ewatchold() {
710 local configtime pid piduptime now
711 local -i count
712 local -a oldpids
713 count=0
714 while true; do
715 oldpids=($(eoldpids))
716 if (( ! ${#oldpids[@]} )); then
717 return
718 fi
719 # print the date every 20 iterations
720 if (( ! count % 20 )); then
721 date
722 fi
723 count+=1
724 ps -f -p "${oldpids[*]}"
725 sleep 1
726 done
727 }
728
729 eless() {
730 less /var/log/exim4/mainlog
731 }
732 ccomp less eless
733 eqcat() {
734 exiqgrep -i -o 60 | while read -r i; do
735 hlm exim -Mvc $i
736 echo
737 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
738 done
739 }
740 eqrmf() {
741 exiqgrep -i | xargs exim -Mrm
742 }
743
744 econfdevnew() {
745 rm -rf /tmp/edev
746 mkdir -p /tmp/edev/etc
747 cp -ra /etc/exim4 /tmp/edev/etc
748 cp -ra /etc/alias* /tmp/edev/etc
749 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
750 econfdev
751 }
752 econfdev() {
753 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
754 }
755
756
757
758 # shellcheck disable=SC2032
759 f() {
760 # cd forward
761 c +
762 }
763
764 fa() {
765 # find array. make an array of file names found by find into $x
766 # argument: find arguments
767 # return: find results in an array $x
768 while read -rd ''; do
769 x+=("$REPLY");
770 done < <(find "$@" -print0);
771 }
772
773 faf() { # find all files. use -L to follow symlinks
774 find "$@" -not \( -name .svn -prune -o -name .git -prune \
775 -o -name .hg -prune -o -name .editor-backups -prune \
776 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
777 }
778
779 # todo: id like to do maybe a daily or hourly cronjob to
780 # check that my history file size is increasing. Ive had it
781 # inexplicably truncated in the past.
782 histrm() {
783 history -n
784 history | awk -v IGNORECASE=1 '{ a=$1; sub(/^( *[^ ]+){4} */, "") }; /'"$*"'/'
785 read -p "press anything but contrl-c to delete"
786 for entry in $(history | awk -v IGNORECASE=1 '{ a=$1; sub(/^( *[^ ]+){4} */, "") }; /'"$*"'/ { print a }' | tac); do
787 history -d $entry
788 done
789 history -w
790 }
791
792 # mail related
793 frozen() {
794 rm -rf /tmp/frozen
795 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
796 sudo exim -Mvl $id
797 echo
798 sudo exim -Mvh $id
799 echo
800 sudo exim -Mvb $id
801 echo -e '\n\n##############################\n'
802 done | tee -a /tmp/frozen
803 }
804 frozenrm() {
805 local ids=()
806 while read -r line; do
807 printf '%s\n' "$line"
808 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
809 done < <(s mailq)
810 echo "sleeping for 2 in case you change your mind"
811 sleep 2
812 sudo exim -Mrm "${ids[@]}"
813 }
814
815 funce() {
816 # like -e for functions. returns on error.
817 # at the end of the function, disable with:
818 # trap ERR
819 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
820 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
821 trap ERR
822 return' ERR
823 }
824
825 getdir () {
826 local help="Usage: getdir [--help] PATH
827 Output the directory of PATH, or just PATH if it is a directory."
828 if [[ $1 == --help ]]; then
829 echo "$help"
830 return 0
831 fi
832 if [[ $# -ne 1 ]]; then
833 echo "getdir error: expected 1 argument, got $#"
834 return 1
835 fi
836 if [[ -d $1 ]]; then
837 echo "$1"
838 else
839 local dir
840 dir="$(dirname "$1")"
841 if [[ -d $dir ]]; then
842 echo "$dir"
843 else
844 echo "getdir error: directory does not exist"
845 return 1
846 fi
847 fi
848 }
849
850 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
851 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
852 local root
853 root=$(gitroot) || return 1 # function to set gitroot
854 builtin cd "$root"
855 git symbolic-ref HEAD refs/heads/$1
856 rm .git/index
857 git clean -fdx
858 }
859
860 # shellcheck disable=SC2120
861 gitroot() {
862 local help="Usage: gitroot [--help]
863 Print the full path to the root of the current git repo
864
865 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
866 and works in older versions of git which did not have that."
867 if [[ $1 == --help ]]; then
868 echo "$help"
869 return
870 fi
871 local p
872 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
873 [[ $p != /* ]] && p=$PWD
874 echo "${p%%/.git}"
875 }
876
877 g() {
878
879 # todo: patch emacs so it will look elsewhere. this is kinda sad:
880 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
881
882 local args gdb=false
883
884 if [[ $EMACSDIR ]]; then
885 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
886 fi
887
888 if [[ $DISPLAY ]]; then
889 args=-n
890 fi
891
892 if (( $# == 0 )); then
893 args+=" -c"
894 fi
895 # duplicate -c, but oh well
896 if ! pgrep -u $EUID emacsclient; then
897 if (( $# == 0 )) && type -p gdb &>/dev/null; then
898 gdb=true
899 else
900 args+=" -c"
901 fi
902 fi
903 if [[ $EMACSDIR ]]; then
904 # Alter the path here, otherwise the nfs mount gets triggered on the
905 # first path lookup when emacs is not being used.
906 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
907 else
908 if $gdb; then
909 # due to a bug, we cant debug from the start unless we get a new gdb
910 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
911 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
912 m emacsclient -a "" $args "$@"
913 sleep 1
914 cd /a/opt/emacs-$(distro-name)$(distro-num)
915 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
916 cd -
917 else
918 m emacsclient -a "" $args "$@"
919 fi
920 fi
921 }
922
923 # force terminal version
924 gn() {
925 g -n "$@"
926 }
927
928 gmacs() {
929 # quit will prompt if the program crashes.
930 gdb -ex=r -ex=quit --args emacs "$@"; r;
931 }
932
933 gdkill() {
934 # kill the emacs daemon
935 pk1 emacs --daemon
936 }
937
938 gr() {
939 grep -iIP --color=auto "$@" || return $?
940 }
941 grr() { # grep recursive
942 # Don't return 1 on nonmatch because this is meant to be
943 # interactive, not in a conditional.
944 if [[ ${#@} == 1 ]]; then
945 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
946 else
947 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
948 fi
949 }
950 ccomp grep gr grr
951
952 rg() { grr "$@"; }
953 ccomp grep rg
954
955 hr() { # horizontal row. used to break up output
956 printf "$(tput setaf 5 2>/dev/null ||:)â–ˆ$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
957 echo
958 }
959 # highlight
960 hl() {
961 local col input_len=0
962 for arg; do
963 input_len=$((input_len + 1 + ${#arg}))
964 done
965 col=$((60 - input_len))
966 printf "\e[1;97;41m%s" "$*"
967 if (( col > 0 )); then
968 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
969 fi
970 echo
971 }
972 hlm() { hl "$*"; "$@"; }
973
974 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
975
976
977 # get latest hub and run it
978 # main command to use:
979 # hub pull-request --no-edit
980 # --no-edit means to use the first commit\'s message as the pull request message.
981 # If that fails, try doing
982 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
983 # where branch is usually master. it does the pr against your current branch.
984 #
985 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
986 # it\'s at ~/.config/hub
987 hub() {
988 local up uptar updir p
989 p=/github/hub/releases/
990 up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
991 uptar=${up##*/}
992 updir=${uptar%.tgz}
993 if [[ ! -e /a/opt/$updir ]]; then
994 rm -rf /a/opt/hub-linux-amd64*
995 wget -P /a/opt $up
996 tar -C /a/opt -zxf /a/opt/$uptar
997 rm -f /a/opt/$uptar
998 fi
999 if ! which hub &>/dev/null; then
1000 sudo /a/opt/$updir/install
1001 fi
1002
1003 # save token across computers
1004 if [[ ! -L ~/.config/hub ]]; then
1005 if [[ -e ~/.config/hub ]]; then
1006 mv ~/.config/hub /p/c/subdir_files/.config/
1007 fi
1008 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1009 conflink
1010 fi
1011 fi
1012 command hub "$@"
1013 }
1014
1015 i() { git "$@"; }
1016 ccomp git i
1017
1018 ic() {
1019 # fast commit all
1020 git commit -am "$*"
1021 }
1022
1023 ipp() {
1024 git pull
1025 git push
1026 }
1027
1028
1029 ifn() {
1030 # insensitive find
1031 find -L . -not \( -name .svn -prune -o -name .git -prune \
1032 -o -name .hg -prune -o -name .editor-backups -prune \
1033 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1034 }
1035
1036 ifd() {
1037 # insensitive find directory
1038 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1039 -o -name .hg -prune -o -name .editor-backups -prune \
1040 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1041 }
1042
1043
1044 ipdrop() {
1045 sudo iptables -A INPUT -s $1 -j DROP
1046 }
1047
1048
1049 istext() {
1050 grep -Il "" "$@" &>/dev/null
1051 }
1052
1053 jtail() {
1054 journalctl -n 10000 -f "$@"
1055 }
1056 jr() { journalctl "$@" ; }
1057 jrf() { journalctl -f "$@" ; }
1058 jru() {
1059 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
1060 }
1061
1062 l() {
1063 if [[ $PWD == /[iap] ]]; then
1064 command ls -A --color=auto -I lost+found "$@"
1065 else
1066 command ls -A --color=auto "$@"
1067 fi
1068 }
1069
1070 lcn() { locate -i "*$**"; }
1071
1072 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1073
1074 lt() { ll -tr "$@"; }
1075
1076 lld() { ll -d "$@"; }
1077
1078 ccomp ls l lg lt lld ll
1079
1080 # low recursively
1081 lowr() {
1082 local f dirs i a
1083 local -a all
1084 for dirs in false true; do
1085 for f; do
1086 if [[ -d $f ]]; then
1087 all=("$f"/**)
1088 # reverse the order to rename the nested dirs first.
1089 # note: 0 element is the dir itself
1090 for ((i=${#all[@]}-1; i>=1; i--)); do
1091 a="${all[i]}"
1092 if $dirs && [[ -d $a ]]; then
1093 # e dirs low "$a" # debug
1094 low "$a"
1095 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1096 # debug
1097 # e not dirs low "$a" # debug
1098 low "$a"
1099 fi
1100 done
1101 fi
1102 # just rename all the top level args on the second pass
1103 if $dirs; then
1104 # e final dirs low "$f" # debug
1105 low "$f"
1106 fi
1107 done
1108 done
1109 }
1110
1111 low() { # make filenames lowercase, remove bad chars
1112 local arg new dir f
1113 for arg; do
1114 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1115 dir="${arg%/*}"
1116 if (( ${#dir} == ${#arg} )); then
1117 dir=.
1118 fi
1119 f="${arg##*/}"
1120 new="${f,,}" # downcase
1121 new="${new//[^[:alnum:]._-]/_}" # sub bad chars
1122 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1123 new="${new%"${new##*[[:alnum:]]}"}"
1124 # remove bad underscores, like __ and _._
1125 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1126 safe_rename "$dir/$f" "$dir/$new" || return 1
1127 done
1128 return 0
1129 }
1130
1131 lower() { # make first letter of filenames lowercase.
1132 local x
1133 for x in "$@"; do
1134 if [[ ${x::1} == [A-Z] ]]; then
1135 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1136 safe_rename "$x" "$y" || return 1
1137 fi
1138 done
1139 }
1140
1141
1142 k() { # history search
1143 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1144 }
1145 ks() { # history search
1146 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1147 }
1148 ccomp grep k ks
1149
1150
1151 make-targets() {
1152 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1153 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1154 }
1155
1156 mkc() {
1157 mkdir "$1"
1158 c "$1"
1159 }
1160 ccomp mkdir mkc
1161
1162 mkct() {
1163 mkc $(mktemp -d)
1164 }
1165
1166 mkt() { # mkdir and touch file
1167 local path="$1"
1168 mkdir -p "$(dirname "$path")"
1169 touch "$path"
1170 }
1171
1172 # shellcheck disable=SC2032
1173 mkdir() { command mkdir -p "$@"; }
1174
1175 nags() {
1176 # https://github.com/HenriWahl/Nagstamon/issues/357
1177 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1178 /usr/lib/notification-daemon/notification-daemon &
1179 fi
1180 /usr/bin/nagstamon &
1181 }
1182
1183 nmt() {
1184 s nmtui-connect "$@"
1185 }
1186
1187 nopanic() {
1188 # shellcheck disable=SC2024
1189 sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
1190 }
1191
1192 p8() { ping "$@" 8.8.8.8; }
1193 p6() { ping6 "$@" 2001:4860:4860::8888; }
1194
1195 pkx() { # package extract
1196 local pkg cached tmp f
1197 c $(mktemp -d)
1198 pkg=$1
1199 # shellcheck disable=SC2012
1200 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1201 if [[ $cached ]]; then
1202 cp $cached .
1203 else
1204 aptitude download $pkg || return 1
1205 fi
1206 tmp=(*); f=${tmp[0]} # only 1 expected
1207 ex $f
1208 rm -f $f
1209 }
1210
1211 # pgrep and kill
1212 pk1() {
1213 local pid
1214 pid=($(pgrep -f "$*"))
1215 case ${#pid[@]} in
1216 1)
1217 # shellcheck disable=SC2128
1218 {
1219 ps -F $pid
1220 m kill $pid
1221 }
1222 ;;
1223 0) echo "no pid found" ;;
1224 *)
1225 ps -F ${pid[@]}
1226 ;;
1227 esac
1228 }
1229
1230 psg () {
1231 local x y help
1232 help="Usage: psg [--help] GREP_ARGS
1233 grep ps and output in a nice format"
1234 if [[ $1 == --help ]]; then
1235 echo "$help"
1236 return
1237 fi
1238 x=$(ps -eF)
1239 # final grep is because some commands tend to have a lot of trailing spaces
1240 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1241 if [[ $y ]]; then
1242 echo "$x" | head -n 1 || [[ $? == 141 ]]
1243 echo "$y"
1244 fi
1245 }
1246
1247 pubip() { curl -4s https://icanhazip.com; }
1248 pubip6() { curl -6s https://icanhazip.com; }
1249 whatismyip() { pubip; }
1250
1251
1252 q() { # start / launch a program in the backround and redir output to null
1253 "$@" &> /dev/null &
1254 }
1255
1256 # shellcheck disable=SC2120
1257 r() {
1258 if [[ $HISTFILE ]]; then
1259 history -a # save history
1260 fi
1261 trap ERR # this avoids a segfault
1262 exit ${1:0}
1263 # i had this redir, not sure why
1264 # exit "$@" 2>/dev/null
1265 }
1266
1267 # scp is insecure and deprecated.
1268 scp() {
1269 rsync --inplace "$@"
1270 }
1271
1272 randport() {
1273 # available high ports are 1024-65535,
1274 # but lets skip things that are more likely to be in use
1275 python3 <<'EOF'
1276 import secrets
1277 print(secrets.SystemRandom().randrange(10002,65500))
1278 EOF
1279 }
1280
1281 # reapply bashrc
1282 reb() {
1283 source ~/.bashrc
1284 }
1285
1286 rl() {
1287 readlink -f "$@"
1288 }
1289 ccomp readlink rl
1290
1291 rsd() {
1292 # rsync, root is required to keep permissions right.
1293 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1294 # --no-times --delete
1295 # basically, make an exact copy, use checksums instead of file times to be more accurate
1296 rsync -ahvic --delete "$@"
1297 }
1298 rsa() {
1299 # like rlu, but dont delete files on the target end which
1300 # do not exist on the original end.
1301 rsync -ahvic "$@"
1302 }
1303 rst() {
1304 # rl without preserving modification time.
1305 rsync -ahvic --delete --no-t "$@"
1306 }
1307 rsu() { # [OPTS] HOST PATH
1308 # eg. rlu -opts frodo /testpath
1309 # relative paths will expanded with readlink -f.
1310 opts=("${@:1:$#-2}") # 1 to last -2
1311 path="${*:$#}" # last
1312 host="${*:$#-1:1}" # last -1
1313 if [[ $path == .* ]]; then
1314 path=$(readlink -f $path)
1315 fi
1316 # rync here uses checksum instead of time so we dont mess with
1317 # unison relying on time as much. g is for group, same reason
1318 # to keep up with unison.
1319 m s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
1320 }
1321 ccomp rsync rsd rsa rst rsu
1322
1323 # find programs listening on a port
1324 ssp() {
1325 local port=$1
1326 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1327 s ss -lpn state listening sport = $port
1328 }
1329
1330 resolvcat() {
1331 local f
1332 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1333 m s nscd -i hosts
1334 fi
1335 f=/etc/resolv.conf
1336 echo $f:; ccat $f
1337 hr; s ss -lpn sport = 53
1338 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1339 # this will fail is dnsmasq is failed
1340 hr; m ser status dnsmasq | cat || :
1341 f=/etc/dnsmasq.conf
1342 hr; echo $f:; ccat $f
1343 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1344 f=/etc/dnsmasq-servers.conf
1345 hr; echo $f:; ccat $f
1346 fi
1347 hr
1348 echo /etc/nsswitch.conf:
1349 grep '^ *hosts:' /etc/nsswitch.conf
1350 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1351 hr; m ser status systemd-resolved | cat || :
1352 hr; m systemd-resolve --status | cat
1353 fi
1354
1355 }
1356 rcat() {
1357 resolvcat | less
1358 }
1359 reresolv() {
1360 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1361 m ser stop nscd
1362 sleep .5
1363 m ser start nscd
1364 m sudo nscd -i hosts
1365 fi
1366 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1367 m sudo systemctl restart dnsmasq
1368 fi
1369 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1370 m sudo systemctl restart systemd-resolved
1371 fi
1372 if type -P resolvectl &>/dev/null; then
1373 resolvectl flush-caches
1374 fi
1375 }
1376
1377 rmstrips() {
1378 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1379 }
1380
1381 s() {
1382 # background
1383 # I use a function because otherwise we cant use in a script,
1384 # cant assign to variable.
1385 #
1386 # note: gksudo is recommended for X apps because it does not set the
1387 # home directory to the same, and thus apps writing to ~ fuck things up
1388 # with root owned files.
1389 #
1390 if [[ $EUID != 0 || $1 == -* ]]; then
1391 # shellcheck disable=SC2034
1392 SUDOD="$PWD" command sudo -i "$@"
1393 DID_SUDO=true
1394 else
1395 "$@"
1396 fi
1397 }
1398 sb() { # sudo bash -c
1399 # use sb instead of s is for sudo redirections,
1400 # eg. sb 'echo "ok fine" > /etc/file'
1401 # shellcheck disable=SC2034
1402 local SUDOD="$PWD"
1403 sudo -i bash -c "$@"
1404 }
1405 ccomp sudo s sb
1406
1407 safe_rename() { # warn and dont rename if file exists.
1408 # mv -n exists, but it\'s silent
1409 if [[ $# != 2 ]]; then
1410 echo safe_rename error: $# args, need 2 >2
1411 return 1
1412 fi
1413 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1414 if [[ -e $2 || -L $2 ]]; then
1415 echo "Cannot rename $1 to $2 as it already exists."
1416 else
1417 mv -vi "$1" "$2"
1418 fi
1419 fi
1420 }
1421
1422
1423 sd() {
1424 sudo dd status=none of="$1"
1425 }
1426
1427 ser() {
1428 if type -p systemctl &>/dev/null; then
1429 s systemctl "$@"
1430 else
1431 if (( $# >= 3 )); then
1432 echo iank: ser expected 2 or less arguments
1433 return 1
1434 fi
1435 s service $2 $1
1436 fi
1437 }
1438 serstat() {
1439 systemctl -n 40 status "$@"
1440 }
1441
1442 seru() { systemctl --user "$@"; }
1443 # like restart, but do nothing if its not already started
1444 srestart() {
1445 local service=$1
1446 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1447 systemctl restart $service
1448 fi
1449 }
1450
1451 setini() { # set a value in a .ini style file
1452 key="$1" value="$2" section="$3" file="$4"
1453 if [[ -s $file ]]; then
1454 sed -ri -f - "$file" <<EOF
1455 # remove existing keys
1456 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1457 # add key
1458 /^\s*\[$section\]/a $key=$value
1459 # from section to eof, do nothing
1460 /^\s*\[$section\]/,\$b
1461 # on the last line, if we haven't found section yet, add section and key
1462 \$a [$section]\\
1463 $key=$value
1464 EOF
1465 else
1466 cat >"$file" <<EOF
1467 [$section]
1468 $key=$value
1469 EOF
1470 fi
1471 }
1472
1473 sgo() { # service go
1474 service=$1
1475 ser restart $service || return 1
1476 if type -p systemctl &>/dev/null; then
1477 ser enable $service
1478 fi
1479 }
1480 soff () {
1481 for service; do
1482 # ignore services that dont exist
1483 if systemctl cat $service &>/dev/null; then
1484 ser stop $service;
1485 ser disable $service
1486 fi
1487 done
1488 }
1489
1490 sgu() {
1491 systemctl list-unit-files | rg "$@"
1492 }
1493
1494
1495 sk() {
1496
1497
1498 # note, if you do something like this
1499 # x=( prefix* )
1500 # then disable the warning with:
1501 # shellcheck disable=SC2206 # globbing is intended
1502
1503 # 2029: "unescaped, this expands on the client side.": yes, I know how ssh works
1504 # 2164: "Use 'cd ... || exit' or 'cd ... || return' in case cd fails.": i have automatic error handling
1505 # 2086: unquoted $var: Quoting every var I set is way too much quotes.
1506 # 2068: Double quote array expansions to avoid re-splitting elements: same as above.
1507 # 2033: command arg is a function name: too many false positives.
1508
1509
1510 # these ones I had disabled, but without a good written explanation, so enabling them temporarily
1511 # 2046: unquoted $(cmd)
1512 # 2119: Functions with optional args get bad warnings when none are passed.
1513
1514 shellcheck -W 999 -x -e 2029,2164,2086,2068,2033 "$@" || return $?
1515 }
1516
1517
1518 # sl: ssh, but firsh rsync our bashrc and related files to a special
1519 # directory on the remote host if needed.
1520
1521 # Some environment variables and files need to be setup for this to work
1522 # (mine are set at the beginning of this file)
1523
1524 # SL_FILES_DIR: Environment variable. Path to folder which should at
1525 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1526 # remote hosts (top level symlinks are resolved) unless the host already
1527 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1528 # control and sync files to separately and already has the ~/.bashrc you
1529 # want. The remote bash will also take its .inputrc config from this
1530 # folder (default of not existing is fine). Mine looks like this:
1531 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1532
1533 # SL_INFO_DIR: Environment variable. This folder stores info about what
1534 # we detected on the remote system and when we last synced. It will be created
1535 # if it does not exist. Sometimes you may want to forget about a
1536 # remote system, you can use sl --rsync, or the function for that slr
1537 # below.
1538
1539 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1540 # depending on the remote host. Run this string on the remote host the
1541 # first time sl is run (or if we run slr). The result is passed to
1542 # SL_TEST_HOOK. For example,
1543 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1544
1545 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1546 # $SL_FILES_DIR to vary the files synced.
1547
1548 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1549 # example to exclude files within a directory. Note, excluded
1550 # files wont be deleted on rsync, you can add --delete-excluded
1551 # to the rsync command if that is desired.
1552
1553 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1554
1555 # For when ~/.bashrc is already customized on the remote server, you
1556 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1557 # commands, even in scripts. This paragraph is all about that. bash
1558 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1559 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1560 # and if you customize it, probably has bugs from time to time. This is
1561 # bad. Here's how I fix it. I have a special condition to "return" in my
1562 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1563 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1564 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1565 # separate file because even if I return early on, the whole file gets
1566 # parsed which can fail if there is a syntax error.
1567 sl() {
1568 # Background on LC_USEBASHRC var (no need to read if you just want to
1569 # use this function): env variables sent across ssh are strictly
1570 # limited, but we get LC_* at least in debian based machines, so we
1571 # just make that * be something no normal program would use. Note, on
1572 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1573 # set, and the inner shell also allows running a nondefault
1574 # .bashrc. This means the outer shell still ran the default .bashrc,
1575 # but that is the best we can do.
1576
1577 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1578 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1579 declare -a args tmpa
1580
1581 args=($SL_SSH_ARGS)
1582
1583 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1584 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1585 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1586 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1587 # [command]
1588
1589 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
1590 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
1591 # [-F configfile] [-I pkcs11] [-i identity_file]
1592 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
1593 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
1594 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
1595
1596 force_rsync=false
1597 if [[ $1 == --rsync ]]; then
1598 force_rsync=true
1599 shift
1600 fi
1601
1602 sl_test_cmd=$SL_TEST_CMD
1603 sl_test_hook=$SL_TEST_HOOK
1604 sl_rsync_args=$SL_RSYNC_ARGS
1605 while [[ $1 ]]; do
1606 case "$1" in
1607 --rsync)
1608 force_rsync=true
1609 ;;
1610 --sl-test-cmd)
1611 sl_test_cmd="$2"
1612 shift
1613 ;;
1614 --sl-test-hook)
1615 sl_test_hook="$2"
1616 shift
1617 ;;
1618 --sl-rsync-args)
1619 sl_rsync_args="$2"
1620 shift
1621 ;;
1622 *)
1623 break
1624 ;;
1625 esac
1626 shift
1627 done
1628
1629 while [[ $1 ]]; do
1630 case "$1" in
1631 # note we dont support things like -4oOption
1632 -[46AaCfGgKkMNnqsTtVvXxYy]*)
1633 args+=("$1"); shift
1634 ;;
1635 -[bcDEeFIiJLlmOopQRSWw]*)
1636 # -oOption etc is valid
1637 if (( ${#1} >= 3 )); then
1638 args+=("$1"); shift
1639 else
1640 args+=("$1" "$2"); shift 2
1641 fi
1642 ;;
1643 *)
1644 break
1645 ;;
1646 esac
1647 done
1648 remote="$1"
1649 if [[ ! $remote ]]; then
1650 echo $0: error hostname required >&2
1651 return 1
1652 fi
1653 shift
1654
1655 if [[ ! $SL_INFO_DIR ]]; then
1656 echo error: missing '$SL_INFO_DIR' env var >&2
1657 return 1
1658 fi
1659
1660 dorsync=false
1661 haveinfo=false
1662 tmpa=($SL_INFO_DIR/???????????"$remote")
1663 sshinfo=${tmpa[0]}
1664 if [[ -e $sshinfo ]]; then
1665 if $force_rsync; then
1666 rm -f $sshinfo
1667 else
1668 haveinfo=true
1669 fi
1670 fi
1671 if $haveinfo; then
1672 tmp=${sshinfo[0]##*/}
1673 tmp2=${tmp::11}
1674 type=${tmp2: -1}
1675 extra_info=$(cat $sshinfo)
1676 else
1677 # we test for string to know ssh succeeded
1678 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
1679 testcmd="if $testbool; then printf y; else printf n; fi"
1680 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
1681 echo failed sl test. doing plain ssh -v
1682 command ssh -v "${args[@]}" "$remote"
1683 fi
1684 if [[ $tmp == y* ]]; then
1685 type=a
1686 else
1687 dorsync=true
1688 type=b
1689 fi
1690 extra_info="${tmp:1}"
1691 fi
1692 if [[ $sl_test_hook ]]; then
1693 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
1694 fi
1695
1696 if $haveinfo && [[ $type == b ]]; then
1697 info_sec=${tmp::10}
1698 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
1699 files_sec=${files_sec%%.*}
1700 if (( files_sec > info_sec )); then
1701 dorsync=true
1702 rm -f $sshinfo
1703 fi
1704 fi
1705
1706 sync_dirname=${SL_FILES_DIR##*/}
1707
1708 if [[ ! $SL_FILES_DIR ]]; then
1709 echo error: missing '$SL_FILES_DIR' env var >&2
1710 return 1
1711 fi
1712
1713 if $dorsync; then
1714 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
1715 fi
1716 if $dorsync || ! $haveinfo; then
1717 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
1718 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
1719 printf "%s\n" "$extra_info" >$sshinfo
1720 chmod 666 $sshinfo
1721 fi
1722 if [[ $type == b ]]; then
1723 if (( ${#@} )); then
1724 # Theres a couple ways to pass arguments, im not sure whats best,
1725 # but relying on bash 4.4+ escape quoting seems most reliable.
1726 command ssh "${args[@]}" "$remote" \
1727 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
1728 elif [[ ! -t 0 ]]; then
1729 # This case is when commands are being piped to ssh.
1730 # Normally, no bashrc gets sourced.
1731 # But, since we are doing all this, lets source it because we can.
1732 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1733 else
1734 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
1735 fi
1736 else
1737 if [[ -t 0 ]]; then
1738 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
1739 else
1740 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
1741 fi
1742 fi
1743 # this function inspired from https://github.com/Russell91/sshrc
1744 }
1745
1746 slr() {
1747 sl --rsync "$@"
1748 }
1749 sss() { # ssh solo
1750 sl -oControlMaster=no -oControlPath=/ "$@"
1751 }
1752 # kill off old shared socket then ssh
1753 ssk() {
1754 m ssh -O exit "$@" || [[ $? == 255 ]]
1755 m sl "$@"
1756 }
1757 ccomp ssh sl slr sss ssk
1758 # plain ssh
1759 ssh() {
1760 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
1761 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
1762 else
1763 LC_USEBASHRC=t command ssh "$@"
1764 fi
1765 }
1766
1767
1768 slog() {
1769 # log with script. timing is $1.t and script is $1.s
1770 # -l to save to ~/typescripts/
1771 # -t to add a timestamp to the filenames
1772 local logdir do_stamp arg_base
1773 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1774 logdir="/a/dt/"
1775 do_stamp=false
1776 while getopts "lt" option
1777 do
1778 case $option in
1779 l ) arg_base=$logdir ;;
1780 t ) do_stamp=true ;;
1781 esac
1782 done
1783 shift $((OPTIND - 1))
1784 arg_base+=$1
1785 [[ -e $logdir ]] || mkdir -p $logdir
1786 $do_stamp && arg_base+=$(date +%F.%T%z)
1787 script -t $arg_base.s 2> $arg_base.t
1788 }
1789 splay() { # script replay
1790 #logRoot="$HOME/typescripts/"
1791 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
1792 scriptreplay "$1.t" "$1.s"
1793 }
1794
1795 sr() {
1796 # sudo redo. be aware, this command may not work right on strange distros or earlier software
1797 if [[ $# == 0 ]]; then
1798 sudo -E bash -c -l "$(history -p '!!')"
1799 else
1800 echo this command redos last history item. no argument is accepted
1801 fi
1802 }
1803
1804 srm () {
1805 # with -ll, less secure but faster.
1806 command srm -ll "$@"
1807 }
1808
1809 srun() {
1810 scp $2 $1:/tmp
1811 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
1812 }
1813
1814
1815 swap() {
1816 local tmp
1817 tmp=$(mktemp)
1818 mv $1 $tmp
1819 mv $2 $1
1820 mv $tmp $2
1821 }
1822
1823 tclock() { # terminal clock
1824 local x
1825 clear
1826 date +%l:%_M
1827 len=60
1828 # this goes to full width
1829 #len=${1:-$((COLUMNS -7))}
1830 x=1
1831 while true; do
1832 if (( x == len )); then
1833 end=true
1834 d="$(date +%l:%_M) "
1835 else
1836 end=false
1837 d=$(date +%l:%M:%_S)
1838 fi
1839 echo -en "\r"
1840 echo -n "$d"
1841 for ((i=0; i<x; i++)); do
1842 if (( i % 6 )); then
1843 echo -n _
1844 else
1845 echo -n .
1846 fi
1847 done
1848 if $end; then
1849 echo
1850 x=1
1851 else
1852 x=$((x+1))
1853 fi
1854 sleep 5
1855 done
1856 }
1857
1858
1859 te() {
1860 # test existence / exists
1861 local ret=0
1862 for x in "$@"; do
1863 [[ -e "$x" || -L "$x" ]] || ret=1
1864 done
1865 return $ret
1866 }
1867
1868 psoff() {
1869 # normally, i would just execute these commands in the function.
1870 # however, DEBUG is not inherited, so we need to run it outside a function.
1871 # And we want to run set -x afterwards to avoid spam, so we cram everything
1872 # in here, and then it will run after this function is done.
1873 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
1874 }
1875 pson() {
1876 PROMPT_COMMAND=prompt-command
1877 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
1878 trap 'settitle "$BASH_COMMAND"' DEBUG
1879 fi
1880 }
1881
1882 tx() { # toggle set -x, and the prompt so it doesnt spam
1883 if [[ $- == *x* ]]; then
1884 set +x
1885 pson
1886 else
1887 psoff
1888 fi
1889 }
1890
1891 psnetns() {
1892 # show all processes in the network namespace $1.
1893 # blank entries appear to be subprocesses/threads
1894 local x netns
1895 netns=$1
1896 ps -w | head -n 1
1897 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
1898 while read -r l; do
1899 x=$(ps -w --no-headers -p $l);
1900 if [[ $x ]]; then echo "$x"; else echo $l; fi;
1901 done
1902 }
1903
1904 m() { printf "%s\n" "$*"; "$@"; }
1905
1906 uptime() {
1907 if type -p uprecords &>/dev/null; then
1908 uprecords -B
1909 else
1910 command uptime
1911 fi
1912 }
1913
1914 virshrm() {
1915 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
1916 }
1917
1918 vm-set-listen(){
1919 local t
1920 t=$(mktemp)
1921 local vm=$1
1922 local ip=$2
1923 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
1924 sed -r "s/listen='[^']+/listen='$ip/"> $t
1925 sudo virsh undefine $vm
1926 sudo virsh define $t
1927 }
1928
1929
1930 vmshare() {
1931 vm-set-listen $1 0.0.0.0
1932 }
1933
1934
1935 vmunshare() {
1936 vm-set-listen $1 127.0.0.1
1937 }
1938
1939 myiwscan() {
1940 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
1941 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
1942 sudo iw dev wls1 scan | sed -rn "
1943 s/^\Wcapability: (.*)/\1/;Ta;h;b
1944 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
1945 # padded to min width of 20
1946 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
1947 "|sort -r
1948 }
1949
1950 # * misc stuff
1951
1952
1953 if $use_color && type -p tput &>/dev/null; then
1954 term_bold="$(tput bold)"
1955 term_red="$(tput setaf 1)"
1956 term_green="$(tput setaf 2)"
1957 term_yellow="$(tput setaf 3)"
1958 term_purple="$(tput setaf 5)"
1959 term_nocolor="$(tput sgr0)" # no font attributes
1960
1961 # unused so far. commented for shellcheck
1962 # term_underl="$(tput smul)"
1963 # term_blue="$(tput setaf 4)"
1964 # term_cyan="$(tput setaf 6)"
1965 fi
1966 # Try to keep environment pollution down, EPA loves us.
1967 unset safe_term match_lhs use_color
1968
1969 # * prompt
1970
1971
1972 if [[ $- == *i* ]]; then
1973
1974
1975 case $HOSTNAME in
1976 bk|je|li)
1977 if [[ $EUID == 1000 ]]; then
1978 system-status _ ||:
1979 fi
1980 ;;
1981 esac
1982
1983
1984 # this needs to come before next ps1 stuff
1985 # this stuff needs bash 4, feb 2009,
1986 # old enough to no longer condition on $BASH_VERSION anymore
1987 shopt -s autocd
1988 shopt -s dirspell
1989 PS1='\w'
1990 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
1991 PROMPT_DIRTRIM=2
1992 bind -m vi-command B:shell-backward-word
1993 bind -m vi-command W:shell-forward-word
1994 fi
1995
1996 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
1997 unset PROMPT_DIRTRIM
1998 PS1="\h:$PS1"
1999 fi
2000
2001 # emacs terminal has problems if this runs slowly,
2002 # so I've thrown a bunch of things at the wall to speed it up.
2003 prompt-command() {
2004 local return=$? # this MUST COME FIRST
2005 local ps_char ps_color
2006 unset IFS
2007
2008 if [[ $HISTFILE ]]; then
2009 history -a # save history
2010 fi
2011
2012 # assigned in brc2
2013 # shellcheck disable=SC1303
2014 if [[ $jr_pid ]]; then
2015 if [[ -e /proc/$jr_pid ]]; then
2016 kill $jr_pid
2017 fi
2018 unset jr_pid
2019 fi
2020
2021 case $return in
2022 0) ps_color="$term_purple"
2023 ps_char='\$'
2024 ;;
2025 *) ps_color="$term_green"
2026 ps_char="$return \\$"
2027 ;;
2028 esac
2029 if [[ ! -O . ]]; then # not owner
2030 if [[ -w . ]]; then # writable
2031 ps_color="$term_bold$term_red"
2032 else
2033 ps_color="$term_bold$term_green"
2034 fi
2035 fi
2036
2037 # faster than sourceing the file im guessing
2038 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2039 eval $(< /dev/shm/iank-status)
2040 fi
2041 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2042 ps_char="@ $ps_char"
2043 fi
2044 # We could test if sudo is active with sudo -nv
2045 # but then we get an email and log of lots of failed sudo commands.
2046 # We could turn those off, but seems better not to.
2047 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2048 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2049 fi
2050 if [[ ! $HISTFILE ]]; then
2051 ps_char="NOHIST $ps_char"
2052 fi
2053 PS1="${PS1%"${PS1#*[wW]}"} $psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2054
2055 # set titlebar. instead, using more advanced
2056 # titelbar below
2057 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2058 }
2059 PROMPT_COMMAND=prompt-command
2060
2061 if [[ $TERM == screen* ]]; then
2062 _title_escape="\033]..2;"
2063 else
2064 # somme sites recommend this, i dunno what the diff is.
2065 #_title_escape="\033]30;"
2066 _title_escape="\033]0;"
2067 fi
2068
2069 settitle () {
2070 # this makes it so we show the current command if
2071 # one is running, otherwise, show nothing
2072
2073 if [[ $1 == prompt-command ]]; then
2074 return 0
2075 fi
2076 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2077 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2078 printf "%s" "$*"
2079 echo -ne "\007"
2080 fi
2081 }
2082
2083 # note, this wont work:
2084 # x=$(mktemp); cp a $x
2085 # I havnt figured out why, bigger fish to fry.
2086 #
2087 # for titlebar.
2088 # condition from the screen man page i think.
2089 # note: duplicated in tx()
2090 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2091 trap 'settitle "$BASH_COMMAND"' DEBUG
2092 else
2093 trap DEBUG
2094 fi
2095
2096 fi
2097
2098 # * stuff that makes sense to be at the end
2099
2100
2101 # best practice
2102 unset IFS
2103
2104 # shellcheck disable=SC1090
2105 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2106
2107 # I had this idea to start a bash shell which would run an initial
2108 # command passed through this env variable, then continue on
2109 # interactively. But the use case I had in mind went away.
2110 #
2111 # if [[ $MY_INIT_CMD ]]; then
2112 # "${MY_INIT_CMD[@]}"
2113 # unset MY_INIT_CMD
2114 # fi
2115
2116 # ensure no bad programs appending to this file will have an affect
2117 return 0